diff --git a/README b/README
index 318a4aa25d..2371304279 100644
--- a/README
+++ b/README
@@ -815,8 +815,6 @@ The following options need to be configured:
 		CONFIG_CMD_PING		* send ICMP ECHO_REQUEST to network
 					  host
 		CONFIG_CMD_RUN		  run command in env variable
-		CONFIG_CMD_SDRAM	* print SDRAM configuration information
-					  (requires CONFIG_CMD_I2C)
 		CONFIG_CMD_SF		* Read/write/erase SPI NOR flash
 		CONFIG_CMD_SOFTSWITCH	* Soft switch setting command for BF60x
 		CONFIG_CMD_SOURCE	  "source" command Support
diff --git a/cmd/Kconfig b/cmd/Kconfig
index c74acd535b..6431d7c70f 100644
--- a/cmd/Kconfig
+++ b/cmd/Kconfig
@@ -776,6 +776,13 @@ config CMD_SAVES
 	  Provides a way to save a binary file using the Motorola S-Record
 	  format over the serial line.
 
+config CMD_SDRAM
+	bool "sdram - Print SDRAM configuration information"
+	help
+	  Provides information about attached SDRAM. This assumed that the
+	  SDRAM has an EEPROM with information that can be read using the
+	  I2C bus. This is only available on some boards.
+
 config CMD_SF
 	bool "sf"
 	help
diff --git a/configs/MPC8349ITXGP_defconfig b/configs/MPC8349ITXGP_defconfig
index 09af09d4c3..f1cfd3705c 100644
--- a/configs/MPC8349ITXGP_defconfig
+++ b/configs/MPC8349ITXGP_defconfig
@@ -9,6 +9,7 @@ CONFIG_HUSH_PARSER=y
 CONFIG_SYS_PROMPT="MPC8349E-mITX-GP> "
 CONFIG_CMD_I2C=y
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_SETEXPR is not set
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_PING=y
diff --git a/configs/MPC8349ITX_LOWBOOT_defconfig b/configs/MPC8349ITX_LOWBOOT_defconfig
index 0650c7979a..4974dd1a9c 100644
--- a/configs/MPC8349ITX_LOWBOOT_defconfig
+++ b/configs/MPC8349ITX_LOWBOOT_defconfig
@@ -12,6 +12,7 @@ CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
 CONFIG_CMD_SATA=y
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_SETEXPR is not set
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_PING=y
diff --git a/configs/MPC8349ITX_defconfig b/configs/MPC8349ITX_defconfig
index 3763f49ba6..22805ae63e 100644
--- a/configs/MPC8349ITX_defconfig
+++ b/configs/MPC8349ITX_defconfig
@@ -12,6 +12,7 @@ CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
 CONFIG_CMD_SATA=y
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_SETEXPR is not set
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_PING=y
diff --git a/configs/MigoR_defconfig b/configs/MigoR_defconfig
index b8e2da2678..a62d3172d0 100644
--- a/configs/MigoR_defconfig
+++ b/configs/MigoR_defconfig
@@ -13,6 +13,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_EDITENV is not set
 # CONFIG_CMD_ENV_EXISTS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/alt_defconfig b/configs/alt_defconfig
index 109b1abfe7..4dc13d681c 100644
--- a/configs/alt_defconfig
+++ b/configs/alt_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/ap325rxa_defconfig b/configs/ap325rxa_defconfig
index 8c1aaf2c3c..fedaad9677 100644
--- a/configs/ap325rxa_defconfig
+++ b/configs/ap325rxa_defconfig
@@ -14,6 +14,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_ENV_EXISTS is not set
 CONFIG_CMD_IDE=y
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/ap_sh4a_4a_defconfig b/configs/ap_sh4a_4a_defconfig
index 400cfd10a7..c229cf725e 100644
--- a/configs/ap_sh4a_4a_defconfig
+++ b/configs/ap_sh4a_4a_defconfig
@@ -15,6 +15,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/armadillo-800eva_defconfig b/configs/armadillo-800eva_defconfig
index 8b2448b1fc..53d8ec1016 100644
--- a/configs/armadillo-800eva_defconfig
+++ b/configs/armadillo-800eva_defconfig
@@ -18,6 +18,7 @@ CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_FLASH is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/blanche_defconfig b/configs/blanche_defconfig
index c2a4c8092f..a4f02fe882 100644
--- a/configs/blanche_defconfig
+++ b/configs/blanche_defconfig
@@ -9,6 +9,7 @@ CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_IMLS is not set
 # CONFIG_CMD_XIMG is not set
 CONFIG_CMD_MMC=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/ecovec_defconfig b/configs/ecovec_defconfig
index 532b22d3be..4a5bed30c3 100644
--- a/configs/ecovec_defconfig
+++ b/configs/ecovec_defconfig
@@ -17,6 +17,7 @@ CONFIG_VERSION_VARIABLE=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/espt_defconfig b/configs/espt_defconfig
index a41704ec96..a87edf1daf 100644
--- a/configs/espt_defconfig
+++ b/configs/espt_defconfig
@@ -15,6 +15,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/gose_defconfig b/configs/gose_defconfig
index 12b768ca39..885d3ca05b 100644
--- a/configs/gose_defconfig
+++ b/configs/gose_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/koelsch_defconfig b/configs/koelsch_defconfig
index e6eef3f731..a95f372f27 100644
--- a/configs/koelsch_defconfig
+++ b/configs/koelsch_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/lager_defconfig b/configs/lager_defconfig
index ca4f73d04f..7afd59f138 100644
--- a/configs/lager_defconfig
+++ b/configs/lager_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/ms7720se_defconfig b/configs/ms7720se_defconfig
index be5e82aeae..1f436589dd 100644
--- a/configs/ms7720se_defconfig
+++ b/configs/ms7720se_defconfig
@@ -16,6 +16,7 @@ CONFIG_CMD_IDE=y
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
 CONFIG_CMD_PCMCIA=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/ms7722se_defconfig b/configs/ms7722se_defconfig
index 37cf8776c2..d3561da2f0 100644
--- a/configs/ms7722se_defconfig
+++ b/configs/ms7722se_defconfig
@@ -15,6 +15,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/porter_defconfig b/configs/porter_defconfig
index e90fbf1137..21f401aac6 100644
--- a/configs/porter_defconfig
+++ b/configs/porter_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/r0p7734_defconfig b/configs/r0p7734_defconfig
index 91b36058bc..994c156a73 100644
--- a/configs/r0p7734_defconfig
+++ b/configs/r0p7734_defconfig
@@ -15,6 +15,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/r7780mp_defconfig b/configs/r7780mp_defconfig
index 58decc5b52..b2596a4a7a 100644
--- a/configs/r7780mp_defconfig
+++ b/configs/r7780mp_defconfig
@@ -16,6 +16,7 @@ CONFIG_CMD_IDE=y
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/r8a7795_salvator-x_defconfig b/configs/r8a7795_salvator-x_defconfig
index 98eca37710..4203b9cd69 100644
--- a/configs/r8a7795_salvator-x_defconfig
+++ b/configs/r8a7795_salvator-x_defconfig
@@ -12,6 +12,7 @@ CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_IMLS is not set
 CONFIG_CMD_MMC=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/r8a7796_salvator-x_defconfig b/configs/r8a7796_salvator-x_defconfig
index 9e0f9290bf..3c53e47bf1 100644
--- a/configs/r8a7796_salvator-x_defconfig
+++ b/configs/r8a7796_salvator-x_defconfig
@@ -13,6 +13,7 @@ CONFIG_CMD_BOOTZ=y
 # CONFIG_CMD_IMLS is not set
 CONFIG_CMD_MMC=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/rsk7203_defconfig b/configs/rsk7203_defconfig
index f7b99f4842..8f642bf62f 100644
--- a/configs/rsk7203_defconfig
+++ b/configs/rsk7203_defconfig
@@ -14,6 +14,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/sh7752evb_defconfig b/configs/sh7752evb_defconfig
index 124757353b..d6ddbfed54 100644
--- a/configs/sh7752evb_defconfig
+++ b/configs/sh7752evb_defconfig
@@ -18,6 +18,7 @@ CONFIG_CMD_MD5SUM=y
 CONFIG_CMD_MMC=y
 CONFIG_CMD_SF=y
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/sh7753evb_defconfig b/configs/sh7753evb_defconfig
index 68e0c5cdfb..023d2ee97d 100644
--- a/configs/sh7753evb_defconfig
+++ b/configs/sh7753evb_defconfig
@@ -17,6 +17,7 @@ CONFIG_CMD_MD5SUM=y
 CONFIG_CMD_MMC=y
 CONFIG_CMD_SF=y
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/sh7757lcr_defconfig b/configs/sh7757lcr_defconfig
index d43c0184e4..ee9cbc1074 100644
--- a/configs/sh7757lcr_defconfig
+++ b/configs/sh7757lcr_defconfig
@@ -18,6 +18,7 @@ CONFIG_CMD_MD5SUM=y
 CONFIG_CMD_MMC=y
 CONFIG_CMD_SF=y
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/sh7763rdp_defconfig b/configs/sh7763rdp_defconfig
index 32cc565b5e..858d9e250e 100644
--- a/configs/sh7763rdp_defconfig
+++ b/configs/sh7763rdp_defconfig
@@ -15,6 +15,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/sh7785lcr_32bit_defconfig b/configs/sh7785lcr_32bit_defconfig
index d4ebd4b99d..bd5db3edf1 100644
--- a/configs/sh7785lcr_32bit_defconfig
+++ b/configs/sh7785lcr_32bit_defconfig
@@ -17,6 +17,7 @@ CONFIG_VERSION_VARIABLE=y
 CONFIG_CMD_USB=y
 # CONFIG_CMD_FPGA is not set
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/sh7785lcr_defconfig b/configs/sh7785lcr_defconfig
index 5aaca3f574..7547ae475b 100644
--- a/configs/sh7785lcr_defconfig
+++ b/configs/sh7785lcr_defconfig
@@ -16,6 +16,7 @@ CONFIG_VERSION_VARIABLE=y
 CONFIG_CMD_USB=y
 # CONFIG_CMD_FPGA is not set
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/shmin_defconfig b/configs/shmin_defconfig
index 249582f495..8570bbc46a 100644
--- a/configs/shmin_defconfig
+++ b/configs/shmin_defconfig
@@ -14,6 +14,7 @@ CONFIG_VERSION_VARIABLE=y
 # CONFIG_CMD_LOADB is not set
 # CONFIG_CMD_LOADS is not set
 # CONFIG_CMD_FPGA is not set
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_ECHO is not set
 # CONFIG_CMD_ITEST is not set
 # CONFIG_CMD_SOURCE is not set
diff --git a/configs/silk_defconfig b/configs/silk_defconfig
index d2d20b9b96..bd2832843d 100644
--- a/configs/silk_defconfig
+++ b/configs/silk_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/configs/socrates_defconfig b/configs/socrates_defconfig
index f0c1d72f5f..1ab178a175 100644
--- a/configs/socrates_defconfig
+++ b/configs/socrates_defconfig
@@ -15,6 +15,7 @@ CONFIG_CMD_NAND=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
 CONFIG_CMD_PCI=y
+CONFIG_CMD_SDRAM=y
 # CONFIG_CMD_SETEXPR is not set
 CONFIG_CMD_DHCP=y
 # CONFIG_CMD_NFS is not set
diff --git a/configs/stout_defconfig b/configs/stout_defconfig
index bee7401d79..b1467764f7 100644
--- a/configs/stout_defconfig
+++ b/configs/stout_defconfig
@@ -14,6 +14,7 @@ CONFIG_CMD_SF=y
 CONFIG_CMD_SPI=y
 CONFIG_CMD_I2C=y
 CONFIG_CMD_USB=y
+CONFIG_CMD_SDRAM=y
 CONFIG_CMD_DHCP=y
 CONFIG_CMD_MII=y
 CONFIG_CMD_PING=y
diff --git a/include/config_cmd_all.h b/include/config_cmd_all.h
index c72b24284b..25dd3c7355 100644
--- a/include/config_cmd_all.h
+++ b/include/config_cmd_all.h
@@ -13,7 +13,6 @@
  * Alphabetical list of all possible commands.
  */
 
-#define CONFIG_CMD_SDRAM	/* SDRAM DIMM SPD info printout */
 #define CONFIG_CMD_TERMINAL	/* built-in Serial Terminal	*/
 #define CONFIG_CMD_UNIVERSE	/* Tundra Universe Support	*/
 #define CONFIG_CMD_ZFS		/* ZFS Support			*/
diff --git a/include/configs/MPC8349ITX.h b/include/configs/MPC8349ITX.h
index 7d8074b462..212c2e84cb 100644
--- a/include/configs/MPC8349ITX.h
+++ b/include/configs/MPC8349ITX.h
@@ -473,11 +473,6 @@ boards, we say we have two, but don't display a message if we find only one. */
 #define CONFIG_BOOTP_GATEWAY
 #define CONFIG_BOOTP_HOSTNAME
 
-/*
- * Command line configuration.
- */
-#define CONFIG_CMD_SDRAM
-
 #if defined(CONFIG_COMPACT_FLASH) || defined(CONFIG_SATA_SIL3114) \
 				|| defined(CONFIG_USB_STORAGE)
 	#define CONFIG_SUPPORT_VFAT
diff --git a/include/configs/MigoR.h b/include/configs/MigoR.h
index 73b0e6e05a..a311427435 100644
--- a/include/configs/MigoR.h
+++ b/include/configs/MigoR.h
@@ -12,8 +12,6 @@
 #define CONFIG_CPU_SH7722	1
 #define CONFIG_MIGO_R		1
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC0,115200 root=1f01"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/ap325rxa.h b/include/configs/ap325rxa.h
index 448c9279a9..0e0e5f9b43 100644
--- a/include/configs/ap325rxa.h
+++ b/include/configs/ap325rxa.h
@@ -13,8 +13,6 @@
 #define CONFIG_CPU_SH7723	1
 #define CONFIG_AP325RXA	1
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC2,38400"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/ap_sh4a_4a.h b/include/configs/ap_sh4a_4a.h
index adc7d1feba..2f2e4e83f7 100644
--- a/include/configs/ap_sh4a_4a.h
+++ b/include/configs/ap_sh4a_4a.h
@@ -16,8 +16,6 @@
 
 #define CONFIG_SYS_TEXT_BASE 0x8BFC0000
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC4,115200"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/armadillo-800eva.h b/include/configs/armadillo-800eva.h
index 643b26b488..74eebd3aaf 100644
--- a/include/configs/armadillo-800eva.h
+++ b/include/configs/armadillo-800eva.h
@@ -16,8 +16,6 @@
 
 #include <asm/arch/rmobile.h>
 
-#define CONFIG_CMD_SDRAM
-
 #define BOARD_LATE_INIT
 
 #define CONFIG_BOOTARGS		""
diff --git a/include/configs/ecovec.h b/include/configs/ecovec.h
index 2471277c68..7b67d992c0 100644
--- a/include/configs/ecovec.h
+++ b/include/configs/ecovec.h
@@ -28,8 +28,6 @@
 #define CONFIG_ECOVEC_ROMIMAGE_ADDR 0xA0040000
 #define CONFIG_SYS_TEXT_BASE 0x8FFC0000
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC0,115200"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/espt.h b/include/configs/espt.h
index 07f327532b..438580b51f 100644
--- a/include/configs/espt.h
+++ b/include/configs/espt.h
@@ -14,11 +14,6 @@
 #define CONFIG_ESPT	1
 #define __LITTLE_ENDIAN		1
 
-/*
- * Command line configuration.
- */
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS         "console=ttySC0,115200 root=1f01"
 #define CONFIG_ENV_OVERWRITE    1
 
diff --git a/include/configs/ms7720se.h b/include/configs/ms7720se.h
index 112145ce77..77e67aa183 100644
--- a/include/configs/ms7720se.h
+++ b/include/configs/ms7720se.h
@@ -12,8 +12,6 @@
 #define CONFIG_CPU_SH7720	1
 #define CONFIG_MS7720SE		1
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC0,115200"
 #define CONFIG_BOOTFILE		"/boot/zImage"
 #define CONFIG_LOADADDR		0x8E000000
diff --git a/include/configs/ms7722se.h b/include/configs/ms7722se.h
index 49eadd10e9..af7453e71d 100644
--- a/include/configs/ms7722se.h
+++ b/include/configs/ms7722se.h
@@ -12,8 +12,6 @@
 #define CONFIG_CPU_SH7722	1
 #define CONFIG_MS7722SE		1
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC0,115200 root=1f01"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/r0p7734.h b/include/configs/r0p7734.h
index d79aa21c9e..7c2badc3d5 100644
--- a/include/configs/r0p7734.h
+++ b/include/configs/r0p7734.h
@@ -16,8 +16,6 @@
 
 #define CONFIG_SYS_TEXT_BASE 0x8FFC0000
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC3,115200"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/r7780mp.h b/include/configs/r7780mp.h
index 21364ddd4a..271ed53b81 100644
--- a/include/configs/r7780mp.h
+++ b/include/configs/r7780mp.h
@@ -17,11 +17,6 @@
 
 #define CONFIG_DISPLAY_BOARDINFO
 
-/*
- * Command line configuration.
- */
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_CONS_SCIF0	1
 
 #define CONFIG_BOOTARGS		"console=ttySC0,115200"
diff --git a/include/configs/rcar-gen2-common.h b/include/configs/rcar-gen2-common.h
index 16f45f2bea..440984ce86 100644
--- a/include/configs/rcar-gen2-common.h
+++ b/include/configs/rcar-gen2-common.h
@@ -11,8 +11,6 @@
 
 #include <asm/arch/rmobile.h>
 
-#define CONFIG_CMD_SDRAM
-
 /* Support File sytems */
 #define CONFIG_SUPPORT_VFAT
 #define CONFIG_FS_EXT4
diff --git a/include/configs/rcar-gen3-common.h b/include/configs/rcar-gen3-common.h
index 6c23249861..a79d0e60d0 100644
--- a/include/configs/rcar-gen3-common.h
+++ b/include/configs/rcar-gen3-common.h
@@ -12,7 +12,6 @@
 
 #include <asm/arch/rmobile.h>
 
-#define CONFIG_CMD_SDRAM
 #define CONFIG_CMD_EXT2
 #define CONFIG_CMD_EXT4
 #define CONFIG_CMD_EXT4_WRITE
diff --git a/include/configs/rsk7203.h b/include/configs/rsk7203.h
index 58aadbef01..ef054dad39 100644
--- a/include/configs/rsk7203.h
+++ b/include/configs/rsk7203.h
@@ -13,8 +13,6 @@
 #define CONFIG_CPU_SH7203	1
 #define CONFIG_RSK7203	1
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC0,115200"
 #define CONFIG_LOADADDR		0x0C100000 /* RSK7203_SDRAM_BASE + 1MB */
 
diff --git a/include/configs/sh7752evb.h b/include/configs/sh7752evb.h
index 39e8244b25..a7a2750c15 100644
--- a/include/configs/sh7752evb.h
+++ b/include/configs/sh7752evb.h
@@ -14,8 +14,6 @@
 
 #define CONFIG_SYS_TEXT_BASE	0x5ff80000
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC2,115200 root=/dev/nfs ip=dhcp"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/sh7753evb.h b/include/configs/sh7753evb.h
index 24ec0768af..6feed0f7f1 100644
--- a/include/configs/sh7753evb.h
+++ b/include/configs/sh7753evb.h
@@ -14,8 +14,6 @@
 
 #define CONFIG_SYS_TEXT_BASE	0x5ff80000
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC2,115200 root=/dev/nfs ip=dhcp"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/sh7757lcr.h b/include/configs/sh7757lcr.h
index e5084adfcc..11992f5239 100644
--- a/include/configs/sh7757lcr.h
+++ b/include/configs/sh7757lcr.h
@@ -15,8 +15,6 @@
 
 #define CONFIG_SYS_TEXT_BASE	0x8ef80000
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC2,115200 root=/dev/nfs ip=dhcp"
 
 #define CONFIG_DISPLAY_BOARDINFO
diff --git a/include/configs/sh7763rdp.h b/include/configs/sh7763rdp.h
index 74bd9fc29a..327bedb96a 100644
--- a/include/configs/sh7763rdp.h
+++ b/include/configs/sh7763rdp.h
@@ -14,11 +14,6 @@
 #define CONFIG_SH7763RDP	1
 #define __LITTLE_ENDIAN		1
 
-/*
- * Command line configuration.
- */
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS         "console=ttySC2,115200 root=1f01"
 #define CONFIG_ENV_OVERWRITE    1
 
diff --git a/include/configs/sh7785lcr.h b/include/configs/sh7785lcr.h
index f249f4298d..d4477c2794 100644
--- a/include/configs/sh7785lcr.h
+++ b/include/configs/sh7785lcr.h
@@ -12,7 +12,6 @@
 #define CONFIG_CPU_SH7785	1
 #define CONFIG_SH7785LCR	1
 
-#define CONFIG_CMD_SDRAM
 #define CONFIG_CMD_SH_ZIMAGEBOOT
 
 #define CONFIG_BOOTARGS		"console=ttySC1,115200 root=/dev/nfs ip=dhcp"
diff --git a/include/configs/shmin.h b/include/configs/shmin.h
index d31dc558b1..295607808a 100644
--- a/include/configs/shmin.h
+++ b/include/configs/shmin.h
@@ -15,8 +15,6 @@
 /* T-SH7706LSR*/
 /* #define CONFIG_T_SH7706LSR	1 */
 
-#define CONFIG_CMD_SDRAM
-
 #define CONFIG_BOOTARGS		"console=ttySC0,115200"
 
 /*
diff --git a/include/configs/socrates.h b/include/configs/socrates.h
index cce7f901af..27e33a7a78 100644
--- a/include/configs/socrates.h
+++ b/include/configs/socrates.h
@@ -274,11 +274,6 @@
 #define CONFIG_BOOTP_GATEWAY
 #define CONFIG_BOOTP_HOSTNAME
 
-/*
- * Command line configuration.
- */
-#define CONFIG_CMD_SDRAM
-
 #undef CONFIG_WATCHDOG			/* watchdog disabled		*/
 
 /*
diff --git a/scripts/config_whitelist.txt b/scripts/config_whitelist.txt
index 1ae87eb0b5..1d7244c5ee 100644
--- a/scripts/config_whitelist.txt
+++ b/scripts/config_whitelist.txt
@@ -296,7 +296,6 @@ CONFIG_CM922T_XA10
 CONFIG_CMDLINE_EDITING
 CONFIG_CMDLINE_PS_SUPPORT
 CONFIG_CMDLINE_TAG
-CONFIG_CMD_SDRAM
 CONFIG_CMD_SF_TEST
 CONFIG_CMD_SH_ZIMAGEBOOT
 CONFIG_CMD_SPL