diff --git a/README b/README
index 06f3ed0..ea7923e 100644
--- a/README
+++ b/README
@@ -2351,8 +2351,6 @@ The following options need to be configured:
 
 		CONFIG_AT91SAM9XE
 		enable special bootcounter support on at91sam9xe based boards.
-		CONFIG_SOC_DA8XX
-		enable special bootcounter support on da850 based boards.
 		CONFIG_BOOTCOUNT_RAM
 		enable support for the bootcounter in RAM
 		CONFIG_BOOTCOUNT_I2C
diff --git a/arch/arm/mach-davinci/Kconfig b/arch/arm/mach-davinci/Kconfig
index 35e4e9b..e445de6 100644
--- a/arch/arm/mach-davinci/Kconfig
+++ b/arch/arm/mach-davinci/Kconfig
@@ -6,33 +6,38 @@ choice
 
 config TARGET_IPAM390
 	bool "IPAM390 board"
+	select SOC_DA850
 	select SUPPORT_SPL
-	select SYS_DA850_PLL_INIT
-	select SYS_DA850_DDR_INIT
+	
 
 config TARGET_DA850EVM
 	bool "DA850 EVM board"
+	select SOC_DA850
 	select SUPPORT_SPL
 	select SYS_DA850_PLL_INIT
 	select SYS_DA850_DDR_INIT
 
 config TARGET_EA20
 	bool "EA20 board"
+	select SOC_DA850
 	select BOARD_LATE_INIT
 
 config TARGET_OMAPL138_LCDK
 	bool "OMAPL138 LCDK"
+	select SOC_DA850
 	select SUPPORT_SPL
 	select SYS_DA850_PLL_INIT
 	select SYS_DA850_DDR_INIT
 
 config TARGET_CALIMAIN
 	bool "Calimain board"
+	select SOC_DA850
 	select SYS_DA850_PLL_INIT
 	select SYS_DA850_DDR_INIT
 
 config TARGET_LEGOEV3
 	bool "LEGO MINDSTORMS EV3"
+	select SOC_DA850
 	select SYS_DA850_PLL_INIT
 	select SYS_DA850_DDR_INIT
 
@@ -46,6 +51,13 @@ config SYS_DA850_PLL_INIT
 
 config SYS_DA850_DDR_INIT
 	bool
+	
+config SOC_DA850
+	bool
+	select SOC_DA8XX
+	
+config SOC_DA8XX
+	bool
 
 source "board/Barix/ipam390/Kconfig"
 source "board/davinci/da8xxevm/Kconfig"
diff --git a/include/configs/calimain.h b/include/configs/calimain.h
index 60068d1..9f4fc88 100644
--- a/include/configs/calimain.h
+++ b/include/configs/calimain.h
@@ -22,8 +22,6 @@
  * SoC Configuration
  */
 #define CONFIG_MACH_DAVINCI_CALIMAIN
-#define CONFIG_SOC_DA8XX		/* TI DA8xx SoC */
-#define CONFIG_SOC_DA850		/* TI DA850 SoC */
 #define CONFIG_SYS_EXCEPTION_VECTORS_HIGH
 #define CONFIG_SYS_CLK_FREQ		clk_get(DAVINCI_ARM_CLKID)
 #define CONFIG_SYS_OSCIN_FREQ		calimain_get_osc_freq()
diff --git a/include/configs/da850evm.h b/include/configs/da850evm.h
index 3ca5965..82659e4 100644
--- a/include/configs/da850evm.h
+++ b/include/configs/da850evm.h
@@ -34,8 +34,6 @@
  * SoC Configuration
  */
 #define CONFIG_MACH_DAVINCI_DA850_EVM
-#define CONFIG_SOC_DA8XX		/* TI DA8xx SoC */
-#define CONFIG_SOC_DA850		/* TI DA850 SoC */
 #define CONFIG_SYS_EXCEPTION_VECTORS_HIGH
 #define CONFIG_SYS_CLK_FREQ		clk_get(DAVINCI_ARM_CLKID)
 #define CONFIG_SYS_OSCIN_FREQ		24000000
diff --git a/include/configs/ea20.h b/include/configs/ea20.h
index c5e6e9e..528d5bb 100644
--- a/include/configs/ea20.h
+++ b/include/configs/ea20.h
@@ -25,8 +25,6 @@
  * SoC Configuration
  */
 #define CONFIG_MACH_DAVINCI_DA850_EVM
-#define CONFIG_SOC_DA8XX		/* TI DA8xx SoC */
-#define CONFIG_SOC_DA850		/* TI DA850 SoC */
 #define CONFIG_SYS_CLK_FREQ		clk_get(DAVINCI_ARM_CLKID)
 #define CONFIG_SYS_OSCIN_FREQ		24000000
 #define CONFIG_SYS_TIMERBASE		DAVINCI_TIMER0_BASE
diff --git a/include/configs/ipam390.h b/include/configs/ipam390.h
index 1683855..6bf5b98 100644
--- a/include/configs/ipam390.h
+++ b/include/configs/ipam390.h
@@ -25,8 +25,6 @@
  * SoC Configuration
  */
 #define CONFIG_MACH_DAVINCI_DA850_EVM
-#define CONFIG_SOC_DA8XX		/* TI DA8xx SoC */
-#define CONFIG_SOC_DA850		/* TI DA850 SoC */
 #define CONFIG_SYS_EXCEPTION_VECTORS_HIGH
 #define CONFIG_SYS_CLK_FREQ		clk_get(DAVINCI_ARM_CLKID)
 #define CONFIG_SYS_OSCIN_FREQ		24000000
diff --git a/include/configs/legoev3.h b/include/configs/legoev3.h
index c27373c..03dc717 100644
--- a/include/configs/legoev3.h
+++ b/include/configs/legoev3.h
@@ -19,8 +19,6 @@
  * SoC Configuration
  */
 #define CONFIG_MACH_DAVINCI_DA850_EVM
-#define CONFIG_SOC_DA8XX		/* TI DA8xx SoC */
-#define CONFIG_SOC_DA850		/* TI DA850 SoC */
 #define CONFIG_SYS_EXCEPTION_VECTORS_HIGH
 #define CONFIG_SYS_CLK_FREQ		clk_get(DAVINCI_ARM_CLKID)
 #define CONFIG_SYS_OSCIN_FREQ		24000000
diff --git a/include/configs/omapl138_lcdk.h b/include/configs/omapl138_lcdk.h
index 5dba7d2..570322e 100644
--- a/include/configs/omapl138_lcdk.h
+++ b/include/configs/omapl138_lcdk.h
@@ -24,7 +24,6 @@
  */
 #define CONFIG_MACH_OMAPL138_LCDK
 #define CONFIG_ARM926EJS		/* arm926ejs CPU core */
-#define CONFIG_SOC_DA8XX		/* TI DA8xx SoC */
 #define CONFIG_SYS_CLK_FREQ		clk_get(DAVINCI_ARM_CLKID)
 #define CONFIG_SYS_OSCIN_FREQ		24000000
 #define CONFIG_SYS_TIMERBASE		DAVINCI_TIMER0_BASE
diff --git a/scripts/config_whitelist.txt b/scripts/config_whitelist.txt
index 43a4ff0..e33ef59 100644
--- a/scripts/config_whitelist.txt
+++ b/scripts/config_whitelist.txt
@@ -2021,8 +2021,6 @@ CONFIG_SOC_AU1100
 CONFIG_SOC_AU1500
 CONFIG_SOC_AU1550
 CONFIG_SOC_AU1X00
-CONFIG_SOC_DA850
-CONFIG_SOC_DA8XX
 CONFIG_SOC_DM355
 CONFIG_SOC_DM365
 CONFIG_SOC_DM644X